!= Ǯ
!
!= moist adiabat structure
!
! Authors::   Masaki Ishiwatari
! Version::   $Id: moist_conv_adjust.f90,v 1.7 2011-12-02 04:06:36 yot Exp $ 
! Tag Name::  $Name: dcpam5-20120922 $
! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
! License::   See COPYRIGHT[link:../../../COPYRIGHT]

module moist_adiabat
  !
  != Ǯ¤
  !
  != moist adiabat structure
  !
  ! <b>Note that Japanese and English are described in parallel.</b>
  !
  ! Ǯ¤. ٤漾αľʬۤꤹ.
  !
  ! In this module, moist adiabat structure is obtained.
  !
  !== Procedures List
  ! 
  ! MoistAdiabat :: Ǯ¤η
  ! --------------- :: ------------
  ! MoistAdiabat :: moist adiabatic structure
  !
  !== NAMELIST
  !
  ! NAMELIST#moist_adiabat_nml
  !

  ! ⥸塼 ; USE statements
  !

  ! ʻ
  ! Grid points settings
  !
  use gridset, only: imax, & ! ٳʻ. 
                             ! Number of grid points in longitude
    &                jmax, & ! ٳʻ. 
                             ! Number of grid points in latitude
    &                kmax    ! ľؿ. 
                             ! Number of vertical level

  ! ̷ѥ᥿
  ! Kind type parameter
  !
  use dc_types, only: DP, &      ! ټ¿. Double precision. 
    &                 STRING     ! ʸ.       Strings. 

  ! NAMELIST եϤ˴ؤ桼ƥƥ
  ! Utilities for NAMELIST file input
  !
  use namelist_util, only: MaxNmlArySize
                              ! NAMELIST ɤ߹κ祵. 
                              ! Maximum size of arrays loaded from NAMELIST

  ! å
  ! Message output
  !
  use dc_message, only: MessageNotify

  ! ʸ ; Declaration statements
  !
  implicit none
  private

  ! ³
  ! Public procedure
  !
  public:: MoistAdiabat
  public:: MoistAdiabatInit

  ! ѿ
  ! Public variables
  !
  logical, save :: moist_adiabat_inited = .false.
                              ! ե饰. 
                              ! Initialization flag

  ! ѿ
  ! Private variables
  !
  real(DP), save:: RH
                              ! м. 
                              ! relative humidity
  integer, save:: ItrtMax
                              ! ƥ졼. 
                              ! Number of iteration

  real(DP), save:: AdjustCriterion(1:MaxNmlArySize)
                              ! ĴԤ (Ūͥ륮κβٴ)
                              ! Criterion of adjustment (temperature difference 
                              ! equivalent to difference of moist static energy)

  character(*), parameter:: module_name = 'moist_adiabat'
                              ! ⥸塼̾. 
                              ! Module name
  character(*), parameter:: version = &
    & '$Name: dcpam5-20120922 $' // &
    & '$Id: moist_conv_adjust.f90,v 1.7 2011-12-02 04:06:36 yot Exp $'
                              ! ⥸塼ΥС
                              ! Module version

contains

  !--------------------------------------------------------------------------------------

  subroutine MoistAdiabat  &
    &         ( xyz_Temp   , xyz_QVap   , &
    &           xyz_Press   , xyr_Press  , &
    &           xy_SurfTemp ) 
!    &         ( GDT   , GDQ   , &
!    &           GDP   , GDPM  , &
!    &           GDTG  )
    !
    ! Ǯ¤.
    ! ̾ 1 (Ф)򿭤ФƤ
    !
    ! moist adiabat
    !

    ! ⥸塼 ; USE statements
    !

    ! ʪ
    ! Physical constants settings
    !
    use constants, only: &
      & Grav, & 
                              ! $ g $ [m s-2]. 
                              ! ϲ®. 
                              ! Gravitational acceleration
      & GasRDry, &
                              ! $ R $ [J kg-1 K-1]. 
                              ! 絤ε. 
                              ! Gas constant of air
      & CpDry, &
                              ! $ C_p $ [J kg-1 K-1]. 
                              ! 絤갵Ǯ. 
                              ! Specific heat of air at constant pressure
      & LatentHeat
                              ! $ L $ [J kg-1] . 
                              ! ŷǮ. 
                              ! Latent heat of condensation

    ! 
    ! Time control
    !
    use timeset, only: &
      & DelTime, &            ! $ \Delta t $
      & TimeN, &              ! ƥå $ t $ λ. Time of step $ t $. 
      & TimesetClockStart, TimesetClockStop

    ! ҥȥǡ
    ! History data output
    !
    use gtool_historyauto, only: HistoryAutoPut

    ! ˰漾λ
    ! Evaluate saturation specific humidity
    !
    use saturate_nha1992, only:                             &
      & xy_CalcQVapSat , xy_CalcDQVapSatDTemp,  &
      & xyz_CalcQVapSat, xyz_CalcDQVapSatDTemp
! (2012-11-16 )
! saturate.F90 󶡤ƤΤ򤽤Τޤ޻Ȥ褦
! 뤳ȤǤʤ, Ƥ٤.

    ! ʸ ; Declaration statements
    !
    implicit none

    real(DP), intent(inout):: xyz_Temp (0:imax-1, 1:jmax, 1:kmax)
                              ! $ T $ .     . Temperature
!      REAL       xyz_Temp   ( IDIM*JDIM, KMAX )   !"   

    real(DP), intent(inout):: xyz_QVap (0:imax-1, 1:jmax, 1:kmax)
                              ! $ q $ .     漾. Specific humidity
!      REAL       GDQ   ( IDIM*JDIM, KMAX )   !" 漾  

    real(DP), intent(in):: xyz_Press (0:imax-1, 1:jmax, 1:kmax)
                              ! $ p $ .  (٥). 
                              ! Air pressure (full level)
!      REAL       GDP    ( IDIM*JDIM, KMAX )  !"   

    real(DP), intent(in):: xyr_Press (0:imax-1, 1:jmax, 0:kmax)
                              ! $ \hat{p} $ .  (Ⱦ٥). 
                              ! Air pressure (half level)
!      REAL       GDPM   ( IDIM*JDIM, KMAX+1 )!" Ⱦ

  real(DP), intent(in):: xy_SurfTemp (0:imax-1, 1:jmax)
                              ! ɽ̲ (K)
                              ! Surface temperature (K)
!      REAL       xyz_TempG   ( IDIM*JDIM )  !" ɽ̲

!    real(DP):: xyz_QVapSat (0:imax-1, 1:jmax, 1:kmax)
                              ! ˰漾. 
                              ! Saturation specific humidity. 
!    real(DP):: GDQS  

    real(DP):: xy_Press34 (0:imax-1, 1:jmax)
                              ! $ \hat{p} $ .  (3/4 ٥?). 
!    REAL       GDPM34( IDIM*JDIM       )   !" P(K=3/4)

    integer::  IJ, K, ITR, I, J
    integer::  IFPAR, JFPAR

      REAL       ELF, AKAPPA
      REAL       ST, QEXE, QSAT, DQSAT, DQSATB, DT, STEXE
      REAL       DHDT, DHDTB, DTB, ADJPTS

    real(DP):: QSAT1
    real(DP):: QSAT2
    real(DP):: xyz_QSAT1Work (0:imax-1, 1:jmax, 1:kmax)
    real(DP):: xyz_QSAT2Work (0:imax-1, 1:jmax, 1:kmax)
    real(DP):: xyz_DQSatDTempWork1 (0:imax-1, 1:jmax, 1:kmax)
    real(DP):: xyz_DQSatDTempWork2 (0:imax-1, 1:jmax, 1:kmax)

    real(DP):: xyz_SurfTemp (0:imax-1, 1:jmax, 1:kmax)
    real(DP):: xyz_QVapSatWork (0:imax-1, 1:jmax, 1:kmax)

      REAL       MM
      REAL       D1, D2
      REAL       TP, TM
      REAL       M1, M2
      REAL       F
      REAL       QP, QM
      REAL       A,C
      REAL       PP1, PP2

!         < 2. ե׻ >
!
      ELF    = LatentHeat/CpDry
!      ELF    = EL/CP

      AKAPPA = GasRDry / CpDry
!      AKAPPA = RAIR / CP

      do k = 1,kmax
        xyz_SurfTemp(:,:,k) = xy_SurfTemp(:,:)
      end do

!     3/4 ٥ˤ밵
!        do j = 1, jmax
!          do i = 0, imax-1
!         xy_Press34( i,j ) = (   (   xyr_Press( i,j,1 ) ** (1.0d0 + AKAPPA ) &
!     &                        - xyz_Press ( i,j,1 ) ** (1.0d0 + AKAPPA ) ) &
!     &                    / ( (   xyr_Press( i,j,1 ) - xyz_Press( i,j,1 ) ) &
!     &                      * (1.0d0 + AKAPPA) ) &
!     &                  ) &
!     &                   **( 1.0d0/AKAPPA )
!          end do
!        end do

         xy_Press34( :,: ) = (   (   xyr_Press( :,:,1 ) ** (1.0d0 + AKAPPA ) &
     &                        - xyz_Press ( :,:,1 ) ** (1.0d0 + AKAPPA ) ) &
     &                    / ( (   xyr_Press( :,:,1 ) - xyz_Press( :,:,1 ) ) &
     &                      * (1.0d0 + AKAPPA) ) &
     &                  ) &
     &                   **( 1.0d0/AKAPPA )

!             쥤. ָˤ٤!?
!

!
!         < 3. T, q ¤>
!
!
!         < 3.1 ƥ졼(Newton ˡ) >
!
        do j = 1, jmax
          do i = 0, imax-1
            do k = 1, kmax
               do ITR = 1, ItrtMax

               IF(ITR .EQ. 1) THEN
                  IF( K .EQ. 1) THEN
                     xyz_Temp( i,j,1 ) = xy_SurfTemp( i,j )
                  ELSE
                     xyz_Temp(i,j,K) = xyz_Temp(i,j,K-1)
                  END IF
               END IF

               IF (K .EQ. 1) THEN
                  xyz_QSAT1Work &
                    & = xyz_CalcQVapSat(0,imax,1,jmax,1,kmax,xyz_SurfTemp,xyr_Press )
                  QSAT1 = xyz_QSAT1Work(i,j,1)
                  ! (2012-11-16 )
                  ! 嵭, ? SurfPress Ȥ褦ˤ٤?
!                  QSAT2(i,j,k) = xyz_CalcQVapSat ( i,i,j,j,k,k,xyz_Temp, xyz_Press )
                  ! k=1
                  xyz_QSAT2Work = xyz_CalcQVapSat ( 0,imax,1,jmax,1,kmax,xyz_Temp, xyz_Press )
                  QSAT2 = xyz_QSAT2Work (i,j,k)

                  xyz_DQSatDTempWork1 &
                    & = xyz_CalcDQVapSatDTemp( &
                          & 0,imax,1,jmax,1,kmax, &
                          & xyz_SurfTemp, xyz_QSAT1Work)
                  D1 = xyz_DQSatDTempWork1(i,j,1)

                  xyz_DQSatDTempWork2 &
                    & = xyz_CalcDQVapSatDTemp( &
                          & 0,imax,1,jmax,1,kmax, &
                          & xyz_SurfTemp, xyz_QSAT2Work)
                  D2 = xyz_DQSatDTempWork2(i,j,k)

!                  D1 = xy_CalcDQVapSatDTemp( 1,1,1,1,xy_SurfTemp(i,j), QSAT1)
!                  D2 = xy_CalcDQVapSatDTemp( 1,1,1,1,xyz_Temp (i,j,K), QSAT2)

                  TP = xy_SurfTemp( i,j ) + xyz_Temp( i,j,K )
                  TM = xy_SurfTemp( i,j ) - xyz_Temp( i,j,K )
                  PP1 = xyr_Press(i,j,0)/((xyr_Press(i,j,0)+xyz_Press(i,j,1))/2.0)
                  PP2 = xyz_Press(i,j,1)/((xyr_Press(i,j,0)+xyz_Press(i,j,1))/2.0)
               ELSE
!                  QSAT1(1,1) = xy_CalcQVapSat( 1,1,1,1,xyz_Temp( i,j,K-1),xyz_Press(i,j,K-1) )
!                  QSAT2(1,1) = xy_CalcQVapSat( 1,1,1,1,xyz_Temp( i,j,K), xyz_Press( i,j,K) )
                  xyz_QSAT1Work &
                    & = xyz_CalcQVapSat(0,imax,1,jmax,1,kmax,xyz_SurfTemp,xyr_Press )
                  QSAT1 = xyz_Qsat1Work(i,j,k-1)
                  QSAT2 = xyz_Qsat1Work(i,j,k)

!                  D1 = xy_CalcDQVapSatDTemp( 1,1,1,1,xyz_Temp( i,j,K-1), QSAT1  )
!                  D2 = xy_CalcDQVapSatDTemp( 1,1,1,1,xyz_Temp( i,j,K  ), QSAT2  )

                  xyz_DQSatDTempWork1 &
                    & = xyz_CalcDQVapSatDTemp( &
                          & 0,imax,1,jmax,1,kmax, &
                          & xyz_SurfTemp, xyz_QSAT1Work)

                  D1 = xyz_DQSatDTempWork1( i,j,K-1 )
                  D2 = xyz_DQSatDTempWork1( i,j,K )

                  TP = xyz_Temp( i,j,K-1 ) + xyz_Temp( i,j,K )
                  TM = xyz_Temp( i,j,K-1 ) - xyz_Temp( i,j,K )
                  PP1 = xyz_Press(i,j,K-1)/xyr_Press(i,j,K-1)
                  PP2 = xyz_Press(i,j,K  )/xyr_Press(i,j,K-1)
               END IF
               M1 = 1.0 - QSAT1
               M2 = 1.0 - QSAT2
               MM = 1.0 - 0.5 * QSAT1 - 0.5 * QSAT2
               QP = QSAT1 + QSAT2
               QM = QSAT1 - QSAT2

               ST =   AKAPPA/4.0 * TP**2 * MM &
     &               * (PP1 *M1 - PP2*M2) &
     &             - 0.5 * MM**2 * TP * TM &
     &             + ELF/2.0 * QP * MM * TM &
     &             - ELF/2.0 * TP * QM
               C = - AKAPPA/4.0 &
     &               * (   TP**2 * MM * PP2 * D2 &
     &                   + (PP1 * M1 - PP2 * M2)  &
     &                     * ( - 0.5 * TP**2 * D2  &
     &                         + 2.0 * TP * MM)     )  &
     &             + 0.5 * (   MM**2 *(-TP + TM)  &
     &                       - MM * TP * TM * D2 )  &
     &             - ELF/2.0 * ( - QP * MM - 0.5 * QP * TM * D2  &
     &                   + MM * TM * D2 )  &
     &             + ELF/2.0 * ( - TP * D2 + QM ) 
               DT = ST/C

               xyz_Temp  ( i,j,K ) = xyz_Temp( i,j,K ) + DT
!               xyz_QVap  ( i,j,K ) = RH * xy_CalcQVapSat (1,1,1,1,xyz_Temp(i,j,K), xyz_Press( i,j,K ) )
               xyz_QVapSatWork = xyz_CalcQVapSat (0,imax,1,jmax,1,kmax,xyz_Temp, xyz_Press )
               xyz_QVap  ( i,j,K ) = RH * xyz_QVapSatWork (i,j,k)
          end do
        end do
      end do
    end do 

  end subroutine MoistAdiabat

  !--------------------------------------------------------------------------------------

  subroutine MoistAdiabatInit
    !
    ! moist_adiabat ⥸塼νԤޤ. 
    ! NAMELIST#moist_adiabat_nml ɤ߹ߤϤμ³ǹԤޤ. 
    !
    ! "moist_conv_adjust" module is initialized. 
    ! "NAMELIST#moist_adiabat_nml" is loaded in this procedure. 
    !

    ! ⥸塼 ; USE statements
    !

    ! NAMELIST եϤ˴ؤ桼ƥƥ
    ! Utilities for NAMELIST file input
    !
    use namelist_util, only: namelist_filename, NmlutilMsg, NmlutilAryValid

    ! ե
    ! File I/O support
    !
    use dc_iounit, only: FileOpen

    ! ̷ѥ᥿
    ! Kind type parameter
    !
    use dc_types, only: STDOUT ! ɸϤֹ. Unit number of standard output

    ! ʸ
    ! Character handling
    !
    use dc_string, only: StoA

    ! ҥȥǡ
    ! History data output
    !
    use gtool_historyauto, only: HistoryAutoAddVariable

    ! ʸ ; Declaration statements
    !
    implicit none

    integer:: unit_nml        ! NAMELIST ե륪ץֹ. 
                              ! Unit number for NAMELIST file open
    integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT. 
                              ! IOSTAT of NAMELIST read

    ! NAMELIST ѿ
    ! NAMELIST group name
    !
    namelist /moist_adiabat_nml/ &
      & RH, ItrtMax

          ! ǥեͤˤĤƤϽ³ "moist_conv_adjust#CumAdjInit" 
          ! Υɤ򻲾ȤΤ. 
          !
          ! Refer to source codes in the initialization procedure
          ! "moist_conv_adjust#MoistConvAdjustInit" for the default values. 
          !

    ! ¹ʸ ; Executable statement
    !

    if ( moist_adiabat_inited ) return


    ! ǥեͤ
    ! Default values settings
    RH  = 1.0d0
    ItrtMax = 10
    !
!!$    FlagUse = .true.

    ! NAMELIST ɤ߹
    ! NAMELIST is input
    !
    if ( trim(namelist_filename) /= '' ) then
      call FileOpen( unit_nml, &          ! (out)
        & namelist_filename, mode = 'r' ) ! (in)

      rewind( unit_nml )
      read( unit_nml,                  &  ! (in)
        & nml = moist_adiabat_nml, &  ! (out)
        & iostat = iostat_nml )           ! (out)
      close( unit_nml )

      call NmlutilMsg( iostat_nml, module_name ) ! (in)
!!$      if ( iostat_nml == 0 ) write( STDOUT, nml = cumulus_adjust_nml )
    end if

    ! ƥ졼, ԰εƸΥå
    ! Check number of iteration, admissible error of unstability
    !
!    call NmlutilAryValid( module_name, & ! (in)
!      & AdjustCriterion, 'AdjustCriterion', &      ! (in)
!      & ItrtMax,    'ItrtMax' )          ! (in)


    ! ҥȥǡϤΤΤؤѿϿ
    ! Register of variables for history data output
    !
!    call HistoryAutoAddVariable( 'RainCumulus', &
!      & (/ 'lon ', 'lat ', 'time' /), &
!      & 'precipitation by cumulus scheme', 'W m-2' )
!    call HistoryAutoAddVariable( 'DTempDtCumulus', &
!      & (/ 'lon ', 'lat ', 'sig ', 'time' /), &
!      & 'cumulus condensation heating', 'K s-1' )
!    call HistoryAutoAddVariable( 'DQVapDtCumulus', &
!      & (/ 'lon ', 'lat ', 'sig ', 'time' /), &
!      & 'cumulus condensation moistening', 'kg kg-1 s-1' )

    !  ; Print
    !
!    call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
!!$    call MessageNotify( 'M', module_name, '  FlagUse              = %b', l = (/ FlagUse /) )
!    call MessageNotify( 'M', module_name, '  CrtlRH               = %f', d = (/ CrtlRH /) )
!    call MessageNotify( 'M', module_name, '  ItrtMax              = %d', i = (/ ItrtMax /) )
!    call MessageNotify( 'M', module_name, '  AdjustCriterion      = (/ %*r /)', &
!      & r = real( AdjustCriterion(1:ItrtMax) ), n = (/ ItrtMax /) )
!    call MessageNotify( 'M', module_name, '' )
!    call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )

    moist_adiabat_inited = .true.

  end subroutine MoistAdiabatInit

end module moist_adiabat
